<?php

/**
 * @file
 * Contains \Drupal\miniorange_saml_idp\Form\MiniorangeSPInformation.
 */

namespace Drupal\miniorange_saml_idp\Form;

use Drupal\Core\Form\FormBase;
use Drupal\miniorange_saml_idp\MiniorangeSAMLIdpSupport;

class MiniorangeSPInformation extends FormBase
{

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'miniorange_sp_setup';
  }
  public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state)
  {
    
      if (\Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_customer_admin_email') == NULL || \Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_customer_id') == NULL
        || \Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_customer_admin_token') == NULL || \Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_customer_api_key') == NULL) {
        $form['header'] = array(
          '#markup' => '<center><h3>You need to register with miniOrange before using this module.</h3></center>',
        );
        return $form;
      }

      global $base_url;
      $url = \Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_idp_base_url');

      $url = isset($url) && !empty($url)? $url:$base_url;
      $login_url = $url . '/initiatelogon';
      $issuer = $base_url . '/?q=admin/config/people/miniorange_saml_idp/';
      $module_path = drupal_get_path('module', 'miniorange_saml_idp');


        $form['header_top_style_1'] = array('#markup' => '<div class="mo_saml_table_layout_1">',);

        $form['markup_style_1'] = array(
       '#markup' => '<div class="mo_saml_table_layout container">',);

        $form['miniorange_saml_idp_issuerID_1'] = array(
        '#type' => 'textfield',
        '#title' => t('IDP Entity ID/Issuer: </b><a href="' . $base_url . '/admin/config/people/miniorange_saml_idp/licensing"> [Premium]</a>'),
        '#default_value' => $issuer,
        '#attributes' => array( ),
        '#disabled' => TRUE,
        );

        $form['miniorange_saml_idp_update_1'] = array(
        '#type' => 'submit',
        '#value' => t('Update'),
        '#submit' => array('miniorange_saml_idp_update'),
        '#disabled' => TRUE,
        );

        $form['header'] = array(
        '#markup' => '<br><br><center><h3>You will need the following information to'
        . ' configure your Service Provider. Copy it and keep it handy.</h3></center>',
        );

        $header = array(
        'attribute' => array('data' => t('Attribute')),
        'value' => array('data' => t('Value')),
        );

        $options = array();

        $options[0] = array(
        'attribute' => t('IDP-Entity ID / Issuer'),
        'value' => $issuer,
        );

        $options[1] = array(
        'attribute' => t('SAML Login URL'),
        'value' => $login_url,
        );

        $options[2] = array(
        'attribute' => t('SAML Logout URL'),
        'value' => $url,
        );

        $options[3] = array(
        'attribute' => t('Certificate (Optional)'),
        'value' => t('<a href="' . $base_url . '/' . $module_path . '/resources/idp-signing.crt">Download</a>'),
        );

        $options[4] = array(
        'attribute' => t('Response Signed'),
        'value' => t('You can choose to sign your response in
        <a href="' . $base_url . '/admin/config/people/miniorange_saml_idp/idp_setup">Identity Provider</a>'),
        );

        $options[5] = array(
        'attribute' => t('Assertion Signed'),
        'value' => t('You can choose to sign your response in
        <a href="' . $base_url . '/admin/config/people/miniorange_saml_idp/idp_setup">Identity Provider</a>'),
        );

        $form['fieldset']['spinfo'] = array(
        '#theme' => 'table',
        '#header' => $header,
        '#rows' => $options,
        );

        $form['markup_idp_sp'] = array(
        '#markup' => '<div class = "mo_saml_text_center"><h2>OR</h2></div>',
        );

        $form['markup_idp_sp_1'] = array(
        '#markup' => '<b>You can provide this metadata URL to your Service Provider.</b><br/>',
        );

        $form['markup_idp_sp_2'] = array(
        '#markup' => '<div class = "mo_saml_highlight_background_url" code style="background-color:gainsboro;"><b>'
            . '<a target="_blank" href="' . $base_url . '/moidp_metadata">' . $base_url . '/moidp_metadata</a></b></code></div></div>',
        );


      $form['markup_idp_attr_header_top_support'] = array('#markup' => '<div class="mo_saml_table_layout_support_1">',
      );

      $form['markup_support_1'] = array(
          '#markup' => '<h3>Support</h3></h3><div>Need any help? Just send us a query so we can help you.<br /><br /></div>',
      );

      $form['miniorange_saml_email_address_support'] = array(
          '#type' => 'textfield',
          '#attributes' => array('placeholder' => 'Enter your Email'),
          '#required' => TRUE,
      );

      $form['miniorange_saml_phone_number_support'] = array(
          '#type' => 'textfield',
          '#attributes' => array('placeholder' => 'Enter your Phone Number'),
      );

      $form['miniorange_saml_support_query_support'] = array(
          '#type' => 'textarea',
          '#cols' => '10',
          '#rows' => '5',
          '#attributes' => array('placeholder' => 'Write your query here'),
          '#required' => TRUE,
      );

      $form['miniorange_saml_support_submit_click'] = array(
          '#type' => 'submit',
          '#value' => t('Submit Query'),
          '#submit' => array('::saved_support'),
      );

      $form['miniorange_saml_support_note'] = array(
          '#markup' => '<div><br/>If you want custom features in the plugin, just drop an email to <a href="mailto:info@miniorange.com">info@miniorange.com</a></div></div></div>'
      );

    return $form;
  }
 
  public function submitForm(array &$form, \Drupal\Core\Form\FormStateInterface $form_state) {

  }

  function saved_support($form, &$form_state) {
        $email = $form['miniorange_saml_email_address_support']['#value'];
        $phone = $form['miniorange_saml_phone_number_support']['#value'];
        $query = $form['miniorange_saml_support_query_support']['#value'];
        $support = new MiniorangeSAMLIdpSupport($email, $phone, $query);
        $support_response = $support->sendSupportQuery();
        if ($support_response) {
            drupal_set_message(t('Support query successfully sent'));
        } else {
            drupal_set_message(t('Error sending support query'), 'error');
        }
  }
}